//
// Created by lukas on 15.03.21.
//

#include <string>
#include <iostream>
#include <Logger.h>
#include <StaticData.h>
#include "CMDParser.h"

CMDParser::Arguments* CMDParser::parseArguments(int argc, char **argv) {
    for (int i = 1; i < argc; i++) {
        this->processParameter(argv[i]);
    }
    return &args;
}

void CMDParser::processParameter(char *arg) {
    const std::string param = std::string(arg);

    if (param == "-h" || param == "--help") {
        std::cout << "help page: " << std::endl << "[-h] [--help]  print this help page" << std::endl
                  << "[-v] [--version] print the software version" << std::endl
                  << "[-f] [--force] force refresh of ip" << std::endl
                  << "[-l] [--loop] infinite loop to refresh ip every five minutes" << std::endl
                  << "[-c] [--checkconfig] validate configuration" << std::endl
                  << "[-ip] [--currentip] get current global ip" << std::endl
                  << "[no argument] normal ip check and refresh" << std::endl;
        exit(0);
    } else if (param == "-v" || param == "--version") {
        std::cout << "Version " << StaticData::VERSION << std::endl;
        exit(0);
    } else if (param == "-f" || param == "--force") {
        args.force = true;
    } else if (param == "-l" || param == "--loop") {
        args.loop = true;
    } else if (param == "-ip" || param == "--currentip") {
        args.currentIP = true;
    } else {
        Logger::message("unknown argument: " + param + "!  -h for help");
    }
}
