#include <CMDParser.h>
#include <Logger.h>
#include "IPRefresher.h"
#include "Config.h"
#include "api/IPAPI.h"

/**
 * application entry point
 */
int main(int argc, char *argv[]) {
    CMDParser parser;
    CMDParser::Arguments *args = parser.parseArguments(argc, argv);

    if (args->currentIP) {
        IPAPI ipapi;
        const std::string ip = ipapi.getGlobalIp();

        std::cout << "Current global IP: " << ip << std::endl;
        return 0;
    }

    // loop mode
    if (args->loop)
        IPRefresher::startUpService(true);

    // default mode
    if (Config::readConfig()) {
        IPRefresher::checkIPAdress(args->force);
    } else {
        Logger::error("incorrect credentials!");
    }

    return 0;
}